<template>
  <div class="wrapper">
    <el-container>
      <class-list-aside type="TEACHER" />

      <el-main>
        <div
          class="info-box"
          v-if="isTeachingClassListEmpty"
        >
          세션 중인 주제가 없음
        </div>
        <div
          class="info-box"
          v-else-if="!currentTeachingClass"
        >
          왼쪽의 주제 목록으로부터 선택하세요
        </div>
        <div v-else>
          <h3>{{ currentTeachingClass.name }}</h3><hr>

          <!-- TODO: translation -->
          <!-- TODO: Link to each page per button-->
          <el-button @click="onClick('EVALUATION')">주제진단</el-button>
          <el-button @click="onClick('OPEN_KNOWLEDGEMAP_MODAL')">주제지식맵</el-button>
          <el-button @click="onClick('ANALYSIS')">주제저널링</el-button>
          <el-button @click="onClick('SCORING')">채점 항목</el-button>
          <el-button type="primary" @click="onClick('EDIT')">주제수정</el-button>
          <el-button type="danger" @click="onClick('DELETE')">주제삭제</el-button>
          <el-button @click="onClick('Q&A')">Q&amp;A</el-button>
          <br /><br />

          <class-scenario type="TEACHER" />

          <!-- TODO: Implement dummy response about class statistics -->
          <class-statistics />
        </div>
        <el-col>
          <el-dialog
            title="주제 지식맵 & 워드 클라우드"
            :visible.sync="isModalVisible"
            width="70%"
            center
          >
            <class-knowledge-map />
            <span slot="footer" class="dialog-footer">
              <el-button
                type="primary"
                @click="onClick('CONFIRM')"
              >
                Confirm
              </el-button>
            </span>
          </el-dialog>
        </el-col>
      </el-main>
    </el-container>
  </div>
</template>

<style lang="scss" scoped>
.wrapper {
  .info-box {
    background-color: white;
    padding: 200px 0px;
    text-align: center;
  }
}
</style>

<script>
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex';
import ClassScenario from '../partials/ClassScenario';
import ClassStatistics from '../partials/ClassStatistics';
import ClassKnowledgeMap from '../partials/ClassKnowledgeMap';
// import teacherService from '../../services/teacherService';
// import classService from '../../services/classService';
import ClassListAside from '../partials/ClassListAside';


export default {
  name: 'TeacherClassIndex',
  data() {
    return {
      isModalVisible: false,
    };
  },
  computed: {
    ...mapState('class', ['teachingClassList', 'currentClassIndex']),
    ...mapGetters('class', [
      'currentTeachingClass',
      'isTeachingClassListEmpty',
    ]),
  },
  components: {
    ClassScenario,
    ClassStatistics,
    ClassKnowledgeMap,
    ClassListAside,
  },
  methods: {
    ...mapMutations('class', ['deleteTeachingClass']),
    ...mapMutations('analysis', ['updateClassId']),
    ...mapActions('class', ['deleteClass']),
    onClick(type) {
      const vm = this;
      switch (type) {
        case 'SCORING': {
          vm.$router.push(`/a/teacher/class/${vm.currentTeachingClass.class_id}/scoring`);
          break;
        }
        case 'EVALUATION': {
          vm.$router.push(`/a/teacher/class/${vm.currentTeachingClass.class_id}/evaluation`);
          break;
        }
        case 'ANALYSIS': {
          vm.updateClassId({
            classId: vm.currentTeachingClass.class_id,
          });
          vm.$router.push(`/a/teacher/class/${vm.currentTeachingClass.class_id}/journal`);
          break;
        }
        case 'OPEN_KNOWLEDGEMAP_MODAL': {
          vm.isModalVisible = true;
          break;
        }
        case 'CONFIRM': {
          vm.isModalVisible = false;
          break;
        }
        case 'EDIT': {
          vm.$router.push(`/a/teacher/class/${vm.currentTeachingClass.class_id}/edit`);
          break;
        }
        case 'DELETE': {
          vm.$confirm(vm.$t('NOTIFY.WANT_DLT_SUBJ'), `${vm.currentTeachingClass.name || ''} ` + vm.$t('CONFIRM.DELETE'), {
            confirmButtonText: vm.$t('NOTE.CONFIRM'),
            cancelButtonText: vm.$t('NOTIFY.CANCEL'),
            type: 'warning',
          })
            .then(async () => {
              try {
                const index = vm.currentClassIndex;
                await vm.deleteClass();
                vm.deleteTeachingClass({
                  teachingClassIndex: index,
                });
              } catch (error) {
                vm.$notify({
                  title: vm.$t('NOTIFY.FAIL_DEL_SUBJ'),
                  message: error.toString(),
                  type: 'error',
                  duration: 3000,
                });
              }
            })
            .catch(() => {
              vm.$notify({
                title: vm.$t('NOTIFY.CANCELLED'),
                message: vm.$t('NOTIFY.FAIL_DEL_SUBJ'),
                type: 'info',
                duration: 3000,
              });
            });
          break;
        }
        case 'Q&A': {
          vm.$router.push(`/a/class/${vm.currentTeachingClass.class_id}/board/0`);
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
  },
};

</script>
